diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/utils/utils_libraw.cpp libkdcraw/libkdcraw/libraw/src/utils/utils_libraw.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/utils/utils_libraw.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/utils/utils_libraw.cpp	2022-11-07 07:46:31.738795008 +0300
@@ -0,0 +1,607 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/libraw_cxx_defs.h"
+
+#ifdef __cplusplus
+extern "C"
+{
+#endif
+  void default_memory_callback(void *, const char *file, const char *where)
+  {
+    fprintf(stderr, "%s: Out of memory in %s\n", file ? file : "unknown file",
+            where);
+  }
+
+  void default_data_callback(void *, const char *file, const int offset)
+  {
+    if (offset < 0)
+      fprintf(stderr, "%s: Unexpected end of file\n",
+              file ? file : "unknown file");
+    else
+      fprintf(stderr, "%s: data corrupted at %d\n",
+              file ? file : "unknown file", offset);
+  }
+  const char *libraw_strerror(int e)
+  {
+    enum LibRaw_errors errorcode = (LibRaw_errors)e;
+    switch (errorcode)
+    {
+    case LIBRAW_SUCCESS:
+      return "No error";
+    case LIBRAW_UNSPECIFIED_ERROR:
+      return "Unspecified error";
+    case LIBRAW_FILE_UNSUPPORTED:
+      return "Unsupported file format or not RAW file";
+    case LIBRAW_REQUEST_FOR_NONEXISTENT_IMAGE:
+      return "Request for nonexisting image number";
+    case LIBRAW_OUT_OF_ORDER_CALL:
+      return "Out of order call of libraw function";
+    case LIBRAW_NO_THUMBNAIL:
+      return "No thumbnail in file";
+    case LIBRAW_UNSUPPORTED_THUMBNAIL:
+      return "Unsupported thumbnail format";
+    case LIBRAW_INPUT_CLOSED:
+      return "No input stream, or input stream closed";
+    case LIBRAW_MEMPOOL_OVERFLOW:
+      return "Libraw internal mempool overflowed";
+    case LIBRAW_UNSUFFICIENT_MEMORY:
+      return "Unsufficient memory";
+    case LIBRAW_DATA_ERROR:
+      return "Corrupted data or unexpected EOF";
+    case LIBRAW_IO_ERROR:
+      return "Input/output error";
+    case LIBRAW_CANCELLED_BY_CALLBACK:
+      return "Cancelled by user callback";
+    case LIBRAW_BAD_CROP:
+      return "Bad crop box";
+    case LIBRAW_TOO_BIG:
+      return "Image too big for processing";
+    default:
+      return "Unknown error code";
+    }
+  }
+
+#ifdef __cplusplus
+}
+#endif
+
+unsigned LibRaw::parse_custom_cameras(unsigned limit,
+                                      libraw_custom_camera_t table[],
+                                      char **list)
+{
+  if (!list)
+    return 0;
+  unsigned index = 0;
+  for (unsigned i = 0; i < limit; i++)
+  {
+    if (!list[i])
+      break;
+    if (strlen(list[i]) < 10)
+      continue;
+    char *string = (char *)malloc(strlen(list[i]) + 1);
+    strcpy(string, list[i]);
+    char *start = string;
+    memset(&table[index], 0, sizeof(table[0]));
+    for (int j = 0; start && j < 14; j++)
+    {
+      char *end = strchr(start, ',');
+      if (end)
+      {
+        *end = 0;
+        end++;
+      } // move to next char
+      while (isspace(*start) && *start)
+        start++; // skip leading spaces?
+      unsigned val = strtol(start, 0, 10);
+      switch (j)
+      {
+      case 0:
+        table[index].fsize = val;
+        break;
+      case 1:
+        table[index].rw = val;
+        break;
+      case 2:
+        table[index].rh = val;
+        break;
+      case 3:
+        table[index].lm = val;
+        break;
+      case 4:
+        table[index].tm = val;
+        break;
+      case 5:
+        table[index].rm = val;
+        break;
+      case 6:
+        table[index].bm = val;
+        break;
+      case 7:
+        table[index].lf = val;
+        break;
+      case 8:
+        table[index].cf = val;
+        break;
+      case 9:
+        table[index].max = val;
+        break;
+      case 10:
+        table[index].flags = val;
+        break;
+      case 11:
+        strncpy(table[index].t_make, start, sizeof(table[index].t_make) - 1);
+        break;
+      case 12:
+        strncpy(table[index].t_model, start, sizeof(table[index].t_model) - 1);
+        break;
+      case 13:
+        table[index].offset = val;
+        break;
+      default:
+        break;
+      }
+      start = end;
+    }
+    free(string);
+    if (table[index].t_make[0])
+      index++;
+  }
+  return index;
+}
+
+void LibRaw::derror()
+{
+  if (!libraw_internal_data.unpacker_data.data_error &&
+      libraw_internal_data.internal_data.input)
+  {
+    if (libraw_internal_data.internal_data.input->eof())
+    {
+      if (callbacks.data_cb)
+        (*callbacks.data_cb)(callbacks.datacb_data,
+                             libraw_internal_data.internal_data.input->fname(),
+                             -1);
+      throw LIBRAW_EXCEPTION_IO_EOF;
+    }
+    else
+    {
+      if (callbacks.data_cb)
+        (*callbacks.data_cb)(callbacks.datacb_data,
+                             libraw_internal_data.internal_data.input->fname(),
+                             libraw_internal_data.internal_data.input->tell());
+      // throw LIBRAW_EXCEPTION_IO_CORRUPT;
+    }
+  }
+  libraw_internal_data.unpacker_data.data_error++;
+}
+
+const char *LibRaw::version() { return LIBRAW_VERSION_STR; }
+int LibRaw::versionNumber() { return LIBRAW_VERSION; }
+const char *LibRaw::strerror(int p) { return libraw_strerror(p); }
+
+unsigned LibRaw::capabilities()
+{
+  unsigned ret = 0;
+#ifdef USE_RAWSPEED
+  ret |= LIBRAW_CAPS_RAWSPEED;
+#endif
+#ifdef USE_DNGSDK
+  ret |= LIBRAW_CAPS_DNGSDK;
+#ifdef USE_GPRSDK
+  ret |= LIBRAW_CAPS_GPRSDK;
+#endif
+#ifdef LIBRAW_WIN32_UNICODEPATHS
+  ret |= LIBRAW_CAPS_UNICODEPATHS;
+#endif
+#endif
+#ifdef USE_X3FTOOLS
+  ret |= LIBRAW_CAPS_X3FTOOLS;
+#endif
+#ifdef USE_6BY9RPI
+  ret |= LIBRAW_CAPS_RPI6BY9;
+#endif
+  return ret;
+}
+
+int LibRaw::is_sraw()
+{
+  return load_raw == &LibRaw::canon_sraw_load_raw ||
+         load_raw == &LibRaw::nikon_load_sraw;
+}
+int LibRaw::is_coolscan_nef()
+{
+  return load_raw == &LibRaw::nikon_coolscan_load_raw;
+}
+int LibRaw::is_jpeg_thumb()
+{
+  return thumb_load_raw == 0 && write_thumb == &LibRaw::jpeg_thumb;
+}
+
+int LibRaw::is_nikon_sraw() { return load_raw == &LibRaw::nikon_load_sraw; }
+int LibRaw::sraw_midpoint()
+{
+  if (load_raw == &LibRaw::canon_sraw_load_raw)
+    return 8192;
+  else if (load_raw == &LibRaw::nikon_load_sraw)
+    return 2048;
+  else
+    return 0;
+}
+
+void *LibRaw::malloc(size_t t)
+{
+  void *p = memmgr.malloc(t);
+  if (!p)
+    throw LIBRAW_EXCEPTION_ALLOC;
+  return p;
+}
+void *LibRaw::realloc(void *q, size_t t)
+{
+  void *p = memmgr.realloc(q, t);
+  if (!p)
+    throw LIBRAW_EXCEPTION_ALLOC;
+  return p;
+}
+
+void *LibRaw::calloc(size_t n, size_t t)
+{
+  void *p = memmgr.calloc(n, t);
+  if (!p)
+    throw LIBRAW_EXCEPTION_ALLOC;
+  return p;
+}
+void LibRaw::free(void *p) { memmgr.free(p); }
+
+void LibRaw::recycle_datastream()
+{
+  if (libraw_internal_data.internal_data.input &&
+      libraw_internal_data.internal_data.input_internal)
+  {
+    delete libraw_internal_data.internal_data.input;
+    libraw_internal_data.internal_data.input = NULL;
+  }
+  libraw_internal_data.internal_data.input_internal = 0;
+}
+void LibRaw::merror(void *ptr, const char *where)
+{
+  if (ptr)
+    return;
+  if (callbacks.mem_cb)
+    (*callbacks.mem_cb)(callbacks.memcb_data,
+                        libraw_internal_data.internal_data.input
+                            ? libraw_internal_data.internal_data.input->fname()
+                            : NULL,
+                        where);
+  throw LIBRAW_EXCEPTION_ALLOC;
+}
+
+void LibRaw::clearCancelFlag()
+{
+#ifdef _MSC_VER
+  InterlockedExchange(&_exitflag, 0);
+#else
+  __sync_fetch_and_and(&_exitflag, 0);
+#endif
+#ifdef RAWSPEED_FASTEXIT
+  if (_rawspeed_decoder)
+  {
+    RawSpeed::RawDecoder *d =
+        static_cast<RawSpeed::RawDecoder *>(_rawspeed_decoder);
+    d->resumeProcessing();
+  }
+#endif
+}
+
+void LibRaw::setCancelFlag()
+{
+#ifdef _MSC_VER
+  InterlockedExchange(&_exitflag, 1);
+#else
+  __sync_fetch_and_add(&_exitflag, 1);
+#endif
+#ifdef RAWSPEED_FASTEXIT
+  if (_rawspeed_decoder)
+  {
+    RawSpeed::RawDecoder *d =
+        static_cast<RawSpeed::RawDecoder *>(_rawspeed_decoder);
+    d->cancelProcessing();
+  }
+#endif
+}
+
+void LibRaw::checkCancel()
+{
+#ifdef _MSC_VER
+  if (InterlockedExchange(&_exitflag, 0))
+    throw LIBRAW_EXCEPTION_CANCELLED_BY_CALLBACK;
+#else
+  if (__sync_fetch_and_and(&_exitflag, 0))
+    throw LIBRAW_EXCEPTION_CANCELLED_BY_CALLBACK;
+#endif
+}
+
+int LibRaw::is_curve_linear()
+{
+  for (int i = 0; i < 0x10000; i++)
+    if (imgdata.color.curve[i] != i)
+      return 0;
+  return 1;
+}
+
+void LibRaw::free_image(void)
+{
+  if (imgdata.image)
+  {
+    free(imgdata.image);
+    imgdata.image = 0;
+    imgdata.progress_flags = LIBRAW_PROGRESS_START | LIBRAW_PROGRESS_OPEN |
+                             LIBRAW_PROGRESS_IDENTIFY |
+                             LIBRAW_PROGRESS_SIZE_ADJUST |
+                             LIBRAW_PROGRESS_LOAD_RAW;
+  }
+}
+
+int LibRaw::is_phaseone_compressed()
+{
+  return (load_raw == &LibRaw::phase_one_load_raw_c ||
+          load_raw == &LibRaw::phase_one_load_raw);
+}
+
+int LibRaw::is_canon_600() { return load_raw == &LibRaw::canon_600_load_raw; }
+const char *LibRaw::strprogress(enum LibRaw_progress p)
+{
+  switch (p)
+  {
+  case LIBRAW_PROGRESS_START:
+    return "Starting";
+  case LIBRAW_PROGRESS_OPEN:
+    return "Opening file";
+  case LIBRAW_PROGRESS_IDENTIFY:
+    return "Reading metadata";
+  case LIBRAW_PROGRESS_SIZE_ADJUST:
+    return "Adjusting size";
+  case LIBRAW_PROGRESS_LOAD_RAW:
+    return "Reading RAW data";
+  case LIBRAW_PROGRESS_REMOVE_ZEROES:
+    return "Clearing zero values";
+  case LIBRAW_PROGRESS_BAD_PIXELS:
+    return "Removing dead pixels";
+  case LIBRAW_PROGRESS_DARK_FRAME:
+    return "Subtracting dark frame data";
+  case LIBRAW_PROGRESS_FOVEON_INTERPOLATE:
+    return "Interpolating Foveon sensor data";
+  case LIBRAW_PROGRESS_SCALE_COLORS:
+    return "Scaling colors";
+  case LIBRAW_PROGRESS_PRE_INTERPOLATE:
+    return "Pre-interpolating";
+  case LIBRAW_PROGRESS_INTERPOLATE:
+    return "Interpolating";
+  case LIBRAW_PROGRESS_MIX_GREEN:
+    return "Mixing green channels";
+  case LIBRAW_PROGRESS_MEDIAN_FILTER:
+    return "Median filter";
+  case LIBRAW_PROGRESS_HIGHLIGHTS:
+    return "Highlight recovery";
+  case LIBRAW_PROGRESS_FUJI_ROTATE:
+    return "Rotating Fuji diagonal data";
+  case LIBRAW_PROGRESS_FLIP:
+    return "Flipping image";
+  case LIBRAW_PROGRESS_APPLY_PROFILE:
+    return "ICC conversion";
+  case LIBRAW_PROGRESS_CONVERT_RGB:
+    return "Converting to RGB";
+  case LIBRAW_PROGRESS_STRETCH:
+    return "Stretching image";
+  case LIBRAW_PROGRESS_THUMB_LOAD:
+    return "Loading thumbnail";
+  default:
+    return "Some strange things";
+  }
+}
+int LibRaw::adjust_sizes_info_only(void)
+{
+  CHECK_ORDER_LOW(LIBRAW_PROGRESS_IDENTIFY);
+
+  raw2image_start();
+  if (O.use_fuji_rotate)
+  {
+    if (IO.fuji_width)
+    {
+      IO.fuji_width = (IO.fuji_width - 1 + IO.shrink) >> IO.shrink;
+      S.iwidth = (ushort)(IO.fuji_width / sqrt(0.5));
+      S.iheight = (ushort)((S.iheight - IO.fuji_width) / sqrt(0.5));
+    }
+    else
+    {
+      if (S.pixel_aspect < 0.995)
+        S.iheight = (ushort)(S.iheight / S.pixel_aspect + 0.5);
+      if (S.pixel_aspect > 1.005)
+        S.iwidth = (ushort)(S.iwidth * S.pixel_aspect + 0.5);
+    }
+  }
+  SET_PROC_FLAG(LIBRAW_PROGRESS_FUJI_ROTATE);
+  if (S.flip & 4)
+  {
+    unsigned short t = S.iheight;
+    S.iheight = S.iwidth;
+    S.iwidth = t;
+    SET_PROC_FLAG(LIBRAW_PROGRESS_FLIP);
+  }
+  return 0;
+}
+int LibRaw::adjust_maximum()
+{
+  ushort real_max;
+  float auto_threshold;
+
+  if (O.adjust_maximum_thr < 0.00001)
+    return LIBRAW_SUCCESS;
+  else if (O.adjust_maximum_thr > 0.99999)
+    auto_threshold = LIBRAW_DEFAULT_ADJUST_MAXIMUM_THRESHOLD;
+  else
+    auto_threshold = O.adjust_maximum_thr;
+
+  real_max = C.data_maximum;
+  if (real_max > 0 && real_max < C.maximum &&
+      real_max > C.maximum * auto_threshold)
+  {
+    C.maximum = real_max;
+  }
+  return LIBRAW_SUCCESS;
+}
+void LibRaw::adjust_bl()
+{
+  int clear_repeat = 0;
+  if (O.user_black >= 0)
+  {
+    C.black = O.user_black;
+    clear_repeat = 1;
+  }
+  for (int i = 0; i < 4; i++)
+    if (O.user_cblack[i] > -1000000)
+    {
+      C.cblack[i] = O.user_cblack[i];
+      clear_repeat = 1;
+    }
+
+  if (clear_repeat)
+    C.cblack[4] = C.cblack[5] = 0;
+
+  // Add common part to cblack[] early
+  if (imgdata.idata.filters > 1000 && (C.cblack[4] + 1) / 2 == 1 &&
+      (C.cblack[5] + 1) / 2 == 1)
+  {
+    int clrs[4];
+    int lastg = -1, gcnt = 0;
+    for (int c = 0; c < 4; c++)
+    {
+      clrs[c] = FC(c / 2, c % 2);
+      if (clrs[c] == 1)
+      {
+        gcnt++;
+        lastg = c;
+      }
+    }
+    if (gcnt > 1 && lastg >= 0)
+      clrs[lastg] = 3;
+    for (int c = 0; c < 4; c++)
+      C.cblack[clrs[c]] +=
+          C.cblack[6 + c / 2 % C.cblack[4] * C.cblack[5] + c % 2 % C.cblack[5]];
+    C.cblack[4] = C.cblack[5] = 0;
+    // imgdata.idata.filters = sfilters;
+  }
+  else if (imgdata.idata.filters <= 1000 && C.cblack[4] == 1 &&
+           C.cblack[5] == 1) // Fuji RAF dng
+  {
+    for (int c = 0; c < 4; c++)
+      C.cblack[c] += C.cblack[6];
+    C.cblack[4] = C.cblack[5] = 0;
+  }
+  // remove common part from C.cblack[]
+  int i = C.cblack[3];
+  int c;
+  for (c = 0; c < 3; c++)
+    if (i > (int)C.cblack[c])
+      i = C.cblack[c];
+
+  for (c = 0; c < 4; c++)
+    C.cblack[c] -= i; // remove common part
+  C.black += i;
+
+  // Now calculate common part for cblack[6+] part and move it to C.black
+
+  if (C.cblack[4] && C.cblack[5])
+  {
+    i = C.cblack[6];
+    for (c = 1; c < int(C.cblack[4] * C.cblack[5]); c++)
+      if (i > int(C.cblack[6 + c]))
+        i = C.cblack[6 + c];
+    // Remove i from cblack[6+]
+    int nonz = 0;
+    for (c = 0; c < int(C.cblack[4] * C.cblack[5]); c++)
+    {
+      C.cblack[6 + c] -= i;
+      if (C.cblack[6 + c])
+        nonz++;
+    }
+    C.black += i;
+    if (!nonz)
+      C.cblack[4] = C.cblack[5] = 0;
+  }
+  for (c = 0; c < 4; c++)
+    C.cblack[c] += C.black;
+}
+int LibRaw::getwords(char *line, char *words[], int maxwords, int maxlen)
+{
+  line[maxlen - 1] = 0;
+  char *p = line;
+  int nwords = 0;
+
+  while (1)
+  {
+    while (isspace(*p))
+      p++;
+    if (*p == '\0')
+      return nwords;
+    words[nwords++] = p;
+    while (!isspace(*p) && *p != '\0')
+      p++;
+    if (*p == '\0')
+      return nwords;
+    *p++ = '\0';
+    if (nwords >= maxwords)
+      return nwords;
+  }
+}
+int LibRaw::stread(char *buf, size_t len, LibRaw_abstract_datastream *fp)
+{
+  if (len > 0)
+  {
+    int r = fp->read(buf, len, 1);
+    buf[len - 1] = 0;
+    return r;
+  }
+  else
+    return 0;
+}
+
+int LibRaw::find_ifd_by_offset(int o)
+{
+    for(unsigned i = 0; i < libraw_internal_data.identify_data.tiff_nifds && i < LIBRAW_IFD_MAXCOUNT; i++)
+        if(tiff_ifd[i].offset == o)
+            return i;
+    return -1;
+}
+
+short LibRaw::tiff_sget (unsigned save, uchar *buf, unsigned buf_len, INT64 *tag_offset,
+                         unsigned *tag_id, unsigned *tag_type, INT64 *tag_dataoffset,
+                         unsigned *tag_datalen, int *tag_dataunitlen) {
+  uchar *pos = buf + *tag_offset;
+  if ((((*tag_offset) + 12) > buf_len) || (*tag_offset < 0)) { // abnormal, tag buffer overrun
+    return -1;
+  }
+  *tag_id      = sget2(pos); pos += 2;
+  *tag_type    = sget2(pos); pos += 2;
+  *tag_datalen = sget4(pos); pos += 4;
+  *tag_dataunitlen = tagtype_dataunit_bytes[(*tag_type <= LIBRAW_EXIFTAG_TYPE_IFD8) ? *tag_type : 0];
+  if ((*tag_datalen * (*tag_dataunitlen)) > 4) {
+    *tag_dataoffset = sget4(pos) - save;
+    if ((*tag_dataoffset + *tag_datalen) > buf_len) { // abnormal, tag data buffer overrun
+      return -2;
+    }
+  } else *tag_dataoffset = *tag_offset + 8;
+  *tag_offset += 12;
+  return 0;
+}
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/write/apply_profile.cpp libkdcraw/libkdcraw/libraw/src/write/apply_profile.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/write/apply_profile.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/write/apply_profile.cpp	2022-11-07 07:46:31.738795008 +0300
@@ -0,0 +1,77 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw uses code from dcraw.c -- Dave Coffin's raw photo decoder,
+ dcraw.c is copyright 1997-2018 by Dave Coffin, dcoffin a cybercom o net.
+ LibRaw do not use RESTRICTED code from dcraw.c
+
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/dcraw_fileio_defs.h"
+
+#ifndef NO_LCMS
+void LibRaw::apply_profile(const char *input, const char *output)
+{
+  char *prof;
+  cmsHPROFILE hInProfile = 0, hOutProfile = 0;
+  cmsHTRANSFORM hTransform;
+  FILE *fp;
+  unsigned size;
+
+  if (strcmp(input, "embed"))
+    hInProfile = cmsOpenProfileFromFile(input, "r");
+  else if (profile_length)
+  {
+    hInProfile = cmsOpenProfileFromMem(imgdata.color.profile, profile_length);
+  }
+  else
+  {
+    imgdata.process_warnings |= LIBRAW_WARN_NO_EMBEDDED_PROFILE;
+  }
+  if (!hInProfile)
+  {
+    imgdata.process_warnings |= LIBRAW_WARN_NO_INPUT_PROFILE;
+    return;
+  }
+  if (!output)
+    hOutProfile = cmsCreate_sRGBProfile();
+  else if ((fp = fopen(output, "rb")))
+  {
+    fread(&size, 4, 1, fp);
+    fseek(fp, 0, SEEK_SET);
+    oprof = (unsigned *)malloc(size = ntohl(size));
+    merror(oprof, "apply_profile()");
+    fread(oprof, 1, size, fp);
+    fclose(fp);
+    if (!(hOutProfile = cmsOpenProfileFromMem(oprof, size)))
+    {
+      free(oprof);
+      oprof = 0;
+    }
+  }
+  if (!hOutProfile)
+  {
+    imgdata.process_warnings |= LIBRAW_WARN_BAD_OUTPUT_PROFILE;
+    goto quit;
+  }
+  RUN_CALLBACK(LIBRAW_PROGRESS_APPLY_PROFILE, 0, 2);
+  hTransform = cmsCreateTransform(hInProfile, TYPE_RGBA_16, hOutProfile,
+                                  TYPE_RGBA_16, INTENT_PERCEPTUAL, 0);
+  cmsDoTransform(hTransform, image, image, width * height);
+  raw_color = 1; /* Don't use rgb_cam with a profile */
+  cmsDeleteTransform(hTransform);
+  cmsCloseProfile(hOutProfile);
+quit:
+  cmsCloseProfile(hInProfile);
+  RUN_CALLBACK(LIBRAW_PROGRESS_APPLY_PROFILE, 1, 2);
+}
+#endif
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/write/file_write.cpp libkdcraw/libkdcraw/libraw/src/write/file_write.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/write/file_write.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/write/file_write.cpp	2022-11-07 07:46:31.738795008 +0300
@@ -0,0 +1,289 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw uses code from dcraw.c -- Dave Coffin's raw photo decoder,
+ dcraw.c is copyright 1997-2018 by Dave Coffin, dcoffin a cybercom o net.
+ LibRaw do not use RESTRICTED code from dcraw.c
+
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/dcraw_defs.h"
+
+int LibRaw::flip_index(int row, int col)
+{
+  if (flip & 4)
+    SWAP(row, col);
+  if (flip & 2)
+    row = iheight - 1 - row;
+  if (flip & 1)
+    col = iwidth - 1 - col;
+  return row * iwidth + col;
+}
+
+void LibRaw::tiff_set(struct tiff_hdr *th, ushort *ntag, ushort tag,
+                      ushort type, int count, int val)
+{
+  struct libraw_tiff_tag *tt;
+  int c;
+
+  tt = (struct libraw_tiff_tag *)(ntag + 1) + (*ntag)++;
+  tt->val.i = val;
+  if (tagtypeIs(LIBRAW_EXIFTAG_TYPE_BYTE) && count <= 4)
+    FORC(4) tt->val.c[c] = val >> (c << 3);
+  else if (tagtypeIs(LIBRAW_EXIFTAG_TYPE_ASCII))
+  {
+    count = strnlen((char *)th + val, count - 1) + 1;
+    if (count <= 4)
+      FORC(4) tt->val.c[c] = ((char *)th)[val + c];
+  }
+  else if (tagtypeIs(LIBRAW_EXIFTAG_TYPE_SHORT) && count <= 2)
+    FORC(2) tt->val.s[c] = val >> (c << 4);
+  tt->count = count;
+  tt->type = type;
+  tt->tag = tag;
+}
+
+#define TOFF(ptr) ((char *)(&(ptr)) - (char *)th)
+
+void LibRaw::tiff_head(struct tiff_hdr *th, int full)
+{
+  int c, psize = 0;
+  struct tm *t;
+
+  memset(th, 0, sizeof *th);
+  th->t_order = htonl(0x4d4d4949) >> 16;
+  th->magic = 42;
+  th->ifd = 10;
+  th->rat[0] = th->rat[2] = 300;
+  th->rat[1] = th->rat[3] = 1;
+  FORC(6) th->rat[4 + c] = 1000000;
+  th->rat[4] *= shutter;
+  th->rat[6] *= aperture;
+  th->rat[8] *= focal_len;
+  strncpy(th->t_desc, desc, 512);
+  strncpy(th->t_make, make, 64);
+  strncpy(th->t_model, model, 64);
+  strcpy(th->soft, "dcraw v" DCRAW_VERSION);
+  t = localtime(&timestamp);
+  sprintf(th->date, "%04d:%02d:%02d %02d:%02d:%02d", t->tm_year + 1900,
+          t->tm_mon + 1, t->tm_mday, t->tm_hour, t->tm_min, t->tm_sec);
+  strncpy(th->t_artist, artist, 64);
+  if (full)
+  {
+    tiff_set(th, &th->ntag, 254, 4, 1, 0);
+    tiff_set(th, &th->ntag, 256, 4, 1, width);
+    tiff_set(th, &th->ntag, 257, 4, 1, height);
+    tiff_set(th, &th->ntag, 258, 3, colors, output_bps);
+    if (colors > 2)
+      th->tag[th->ntag - 1].val.i = TOFF(th->bps);
+    FORC4 th->bps[c] = output_bps;
+    tiff_set(th, &th->ntag, 259, 3, 1, 1);
+    tiff_set(th, &th->ntag, 262, 3, 1, 1 + (colors > 1));
+  }
+  tiff_set(th, &th->ntag, 270, 2, 512, TOFF(th->t_desc));
+  tiff_set(th, &th->ntag, 271, 2, 64, TOFF(th->t_make));
+  tiff_set(th, &th->ntag, 272, 2, 64, TOFF(th->t_model));
+  if (full)
+  {
+    if (oprof)
+      psize = ntohl(oprof[0]);
+    tiff_set(th, &th->ntag, 273, 4, 1, sizeof *th + psize);
+    tiff_set(th, &th->ntag, 277, 3, 1, colors);
+    tiff_set(th, &th->ntag, 278, 4, 1, height);
+    tiff_set(th, &th->ntag, 279, 4, 1,
+             height * width * colors * output_bps / 8);
+  }
+  else
+    tiff_set(th, &th->ntag, 274, 3, 1, "12435867"[flip] - '0');
+  tiff_set(th, &th->ntag, 282, 5, 1, TOFF(th->rat[0]));
+  tiff_set(th, &th->ntag, 283, 5, 1, TOFF(th->rat[2]));
+  tiff_set(th, &th->ntag, 284, 3, 1, 1);
+  tiff_set(th, &th->ntag, 296, 3, 1, 2);
+  tiff_set(th, &th->ntag, 305, 2, 32, TOFF(th->soft));
+  tiff_set(th, &th->ntag, 306, 2, 20, TOFF(th->date));
+  tiff_set(th, &th->ntag, 315, 2, 64, TOFF(th->t_artist));
+  tiff_set(th, &th->ntag, 34665, 4, 1, TOFF(th->nexif));
+  if (psize)
+    tiff_set(th, &th->ntag, 34675, 7, psize, sizeof *th);
+  tiff_set(th, &th->nexif, 33434, 5, 1, TOFF(th->rat[4]));
+  tiff_set(th, &th->nexif, 33437, 5, 1, TOFF(th->rat[6]));
+  tiff_set(th, &th->nexif, 34855, 3, 1, iso_speed);
+  tiff_set(th, &th->nexif, 37386, 5, 1, TOFF(th->rat[8]));
+  if (gpsdata[1])
+  {
+    uchar latref[4] = { (uchar)(gpsdata[29]),0,0,0 },
+          lonref[4] = { (uchar)(gpsdata[30]),0,0,0 };
+    tiff_set(th, &th->ntag, 34853, 4, 1, TOFF(th->ngps));
+    tiff_set(th, &th->ngps, 0, 1, 4, 0x202);
+    tiff_set(th, &th->ngps, 1, 2, 2, TOFF(latref));
+    tiff_set(th, &th->ngps, 2, 5, 3, TOFF(th->gps[0]));
+    tiff_set(th, &th->ngps, 3, 2, 2, TOFF(lonref));
+    tiff_set(th, &th->ngps, 4, 5, 3, TOFF(th->gps[6]));
+    tiff_set(th, &th->ngps, 5, 1, 1, gpsdata[31]);
+    tiff_set(th, &th->ngps, 6, 5, 1, TOFF(th->gps[18]));
+    tiff_set(th, &th->ngps, 7, 5, 3, TOFF(th->gps[12]));
+    tiff_set(th, &th->ngps, 18, 2, 12, TOFF(th->gps[20]));
+    tiff_set(th, &th->ngps, 29, 2, 12, TOFF(th->gps[23]));
+    memcpy(th->gps, gpsdata, sizeof th->gps);
+  }
+}
+
+void LibRaw::jpeg_thumb_writer(FILE *tfp, char *t_humb, int t_humb_length)
+{
+  ushort exif[5];
+  struct tiff_hdr th;
+  fputc(0xff, tfp);
+  fputc(0xd8, tfp);
+  if (strcmp(t_humb + 6, "Exif"))
+  {
+    memcpy(exif, "\xff\xe1  Exif\0\0", 10);
+    exif[1] = htons(8 + sizeof th);
+    fwrite(exif, 1, sizeof exif, tfp);
+    tiff_head(&th, 0);
+    fwrite(&th, 1, sizeof th, tfp);
+  }
+  fwrite(t_humb + 2, 1, t_humb_length - 2, tfp);
+}
+void LibRaw::write_ppm_tiff()
+{
+  struct tiff_hdr th;
+  uchar *ppm;
+  ushort *ppm2;
+  int c, row, col, soff, rstep, cstep;
+  int perc, val, total, t_white = 0x2000;
+
+  perc = width * height * auto_bright_thr;
+
+  if (fuji_width)
+    perc /= 2;
+  if (!((highlight & ~2) || no_auto_bright))
+    for (t_white = c = 0; c < colors; c++)
+    {
+      for (val = 0x2000, total = 0; --val > 32;)
+        if ((total += histogram[c][val]) > perc)
+          break;
+      if (t_white < val)
+        t_white = val;
+    }
+  gamma_curve(gamm[0], gamm[1], 2, (t_white << 3) / bright);
+  iheight = height;
+  iwidth = width;
+  if (flip & 4)
+    SWAP(height, width);
+  ppm = (uchar *)calloc(width, colors * output_bps / 8);
+  ppm2 = (ushort *)ppm;
+  merror(ppm, "write_ppm_tiff()");
+  if (output_tiff)
+  {
+    tiff_head(&th, 1);
+    fwrite(&th, sizeof th, 1, ofp);
+    if (oprof)
+      fwrite(oprof, ntohl(oprof[0]), 1, ofp);
+  }
+  else if (colors > 3)
+    fprintf(
+        ofp,
+        "P7\nWIDTH %d\nHEIGHT %d\nDEPTH %d\nMAXVAL %d\nTUPLTYPE %s\nENDHDR\n",
+        width, height, colors, (1 << output_bps) - 1, cdesc);
+  else
+    fprintf(ofp, "P%d\n%d %d\n%d\n", colors / 2 + 5, width, height,
+            (1 << output_bps) - 1);
+  soff = flip_index(0, 0);
+  cstep = flip_index(0, 1) - soff;
+  rstep = flip_index(1, 0) - flip_index(0, width);
+  for (row = 0; row < height; row++, soff += rstep)
+  {
+    for (col = 0; col < width; col++, soff += cstep)
+      if (output_bps == 8)
+        FORCC ppm[col * colors + c] = curve[image[soff][c]] >> 8;
+      else
+        FORCC ppm2[col * colors + c] = curve[image[soff][c]];
+    if (output_bps == 16 && !output_tiff && htons(0x55aa) != 0x55aa)
+      swab((char *)ppm2, (char *)ppm2, width * colors * 2);
+    fwrite(ppm, colors * output_bps / 8, width, ofp);
+  }
+  free(ppm);
+}
+void LibRaw::ppm_thumb()
+{
+  char *thumb;
+  thumb_length = thumb_width * thumb_height * 3;
+  thumb = (char *)malloc(thumb_length);
+  merror(thumb, "ppm_thumb()");
+  fprintf(ofp, "P6\n%d %d\n255\n", thumb_width, thumb_height);
+  fread(thumb, 1, thumb_length, ifp);
+  fwrite(thumb, 1, thumb_length, ofp);
+  free(thumb);
+}
+
+void LibRaw::ppm16_thumb()
+{
+  unsigned i;
+  char *thumb;
+  thumb_length = thumb_width * thumb_height * 3;
+  thumb = (char *)calloc(thumb_length, 2);
+  merror(thumb, "ppm16_thumb()");
+  read_shorts((ushort *)thumb, thumb_length);
+  for (i = 0; i < thumb_length; i++)
+    thumb[i] = ((ushort *)thumb)[i] >> 8;
+  fprintf(ofp, "P6\n%d %d\n255\n", thumb_width, thumb_height);
+  fwrite(thumb, 1, thumb_length, ofp);
+  free(thumb);
+}
+
+void LibRaw::layer_thumb()
+{
+  unsigned int i;
+  int c;
+  char *thumb, map[][4] = {"012", "102"};
+
+  colors = thumb_misc >> 5 & 7;
+  thumb_length = thumb_width * thumb_height;
+  thumb = (char *)calloc(colors, thumb_length);
+  merror(thumb, "layer_thumb()");
+  fprintf(ofp, "P%d\n%d %d\n255\n", 5 + (colors >> 1), thumb_width,
+          thumb_height);
+  fread(thumb, thumb_length, colors, ifp);
+  for (i = 0; i < thumb_length; i++)
+    FORCC putc(thumb[i + thumb_length * (map[thumb_misc >> 8][c] - '0')], ofp);
+  free(thumb);
+}
+
+void LibRaw::rollei_thumb()
+{
+  unsigned i;
+  ushort *thumb;
+
+  thumb_length = thumb_width * thumb_height;
+  thumb = (ushort *)calloc(thumb_length, 2);
+  merror(thumb, "rollei_thumb()");
+  fprintf(ofp, "P6\n%d %d\n255\n", thumb_width, thumb_height);
+  read_shorts(thumb, thumb_length);
+  for (i = 0; i < thumb_length; i++)
+  {
+    putc(thumb[i] << 3, ofp);
+    putc(thumb[i] >> 5 << 2, ofp);
+    putc(thumb[i] >> 11 << 3, ofp);
+  }
+  free(thumb);
+}
+
+void LibRaw::jpeg_thumb()
+{
+  char *thumb;
+
+  thumb = (char *)malloc(thumb_length);
+  merror(thumb, "jpeg_thumb()");
+  fread(thumb, 1, thumb_length, ifp);
+  jpeg_thumb_writer(ofp, thumb, thumb_length);
+  free(thumb);
+}
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/write/tiff_writer.cpp libkdcraw/libkdcraw/libraw/src/write/tiff_writer.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/write/tiff_writer.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/write/tiff_writer.cpp	2022-11-07 07:46:31.738795008 +0300
@@ -0,0 +1,68 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw uses code from dcraw.c -- Dave Coffin's raw photo decoder,
+ dcraw.c is copyright 1997-2018 by Dave Coffin, dcoffin a cybercom o net.
+ LibRaw do not use RESTRICTED code from dcraw.c
+
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/libraw_cxx_defs.h"
+
+int LibRaw::dcraw_ppm_tiff_writer(const char *filename)
+{
+  CHECK_ORDER_LOW(LIBRAW_PROGRESS_LOAD_RAW);
+
+  if (!imgdata.image)
+    return LIBRAW_OUT_OF_ORDER_CALL;
+
+  if (!filename)
+    return ENOENT;
+  FILE *f = NULL;
+  if (!strcmp(filename, "-"))
+  {
+#ifdef LIBRAW_WIN32_CALLS
+    _setmode(_fileno(stdout), _O_BINARY);
+#endif
+    f = stdout;
+  }
+  else
+    f = fopen(filename, "wb");
+
+  if (!f)
+    return errno;
+
+  try
+  {
+    if (!libraw_internal_data.output_data.histogram)
+    {
+      libraw_internal_data.output_data.histogram =
+          (int(*)[LIBRAW_HISTOGRAM_SIZE])malloc(
+              sizeof(*libraw_internal_data.output_data.histogram) * 4);
+      merror(libraw_internal_data.output_data.histogram,
+             "LibRaw::dcraw_ppm_tiff_writer()");
+    }
+    libraw_internal_data.internal_data.output = f;
+    write_ppm_tiff();
+    SET_PROC_FLAG(LIBRAW_PROGRESS_FLIP);
+    libraw_internal_data.internal_data.output = NULL;
+    if (strcmp(filename, "-"))
+      fclose(f);
+    return 0;
+  }
+  catch (LibRaw_exceptions err)
+  {
+    if (strcmp(filename, "-"))
+      fclose(f);
+    EXCEPTION_HANDLER(err);
+  }
+}
